package com.vp.plugin.sample.nicknameplugin.actions;

import javax.swing.*;

import com.vp.plugin.*;
import com.vp.plugin.action.*;
import com.vp.plugin.model.*;

public class AddProjectNicknameActionController implements VPActionController {
	
	public void performAction(VPAction aArg0) {
		
		// Adding Project's Nickname
		IProject lProject = ApplicationManager.instance().getProjectManager().getProject();
		
		/*
		 * openapi request plugin showing JOptionPane's dialog pane by ViewManager.showXXXDialog.
		 * It is because the plugin may be running on a non-swing based environment (e.g. SDE-EC or SDE-VS), 
		 * if using JOptionPane directly, the JOptionPane MAY make the GUI have problem.
		 */
		String lNickname = ApplicationManager.instance().getViewManager().showInputDialog(null, "Please enter a new nickname: ");
		if (lNickname != null) {
			boolean lAlreadyExists = false;
			String[] lNicknames = lProject.getNicknames();
			int lCount = lNicknames == null ? 0 : lNicknames.length;
			for (int i = 0; i < lCount; i++) {
				if (lNickname.equals(lNicknames[i])) {
					lAlreadyExists = true;
					break;
				}
			}
			
			if (lAlreadyExists) {
				if (lNickname.equals(lProject.getNickname())) {
					ApplicationManager.instance().getViewManager().showMessageDialog(
							null, 
							"The nickname \'"+lNickname+"\' already exists in project. Cannot 'ADD' it into project again.", 
							"Nickname alreay exists", 
							JOptionPane.INFORMATION_MESSAGE
					);
				}
				else {
					int lResult = ApplicationManager.instance().getViewManager().showConfirmDialog(
							null, 
							"The nickname \'"+lNickname+"\' already exists in project. Cannot 'ADD' it into project again.\n Anyway, do you want to switch to the nickname now?", 
							"Nickname alreay exists", 
							JOptionPane.YES_NO_CANCEL_OPTION
					);
					if (lResult == JOptionPane.YES_OPTION) {
						lProject.setNickname(lNickname);
					}
				}
				
			}
			else {
				lProject.addNickname(lNickname);
				int lResult = ApplicationManager.instance().getViewManager().showConfirmDialog(
						null, 
						"The nickname \'"+lNickname+"\' is added into project. Do you want to switch to the nickname now?", 
						"Nickname added", 
						JOptionPane.YES_NO_CANCEL_OPTION
				);
				if (lResult == JOptionPane.YES_OPTION) {
					lProject.setNickname(lNickname);
				}
			}
			
		}
		
	}
	
	public void update(VPAction aArg0) {
	}
	
}
