package com.vp.plugin.sample.nicknameplugin.actions;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import com.vp.plugin.*;
import com.vp.plugin.action.*;
import com.vp.plugin.model.*;

public class ShowModelElementNamesActionController implements VPContextActionController {

	public void performAction(VPAction aAction, VPContext aContext, ActionEvent aEvent) {
		IModelElement lModelElement = aContext.getModelElement();
		if (lModelElement != null) {
			
			String lProjectNickname = ApplicationManager.instance().getProjectManager().getProject().getNickname();
			if (lProjectNickname == null || lProjectNickname.length() == 0 || "Realname".equals(lProjectNickname)) {
				ApplicationManager.instance().getViewManager().showMessageDialog(null, "Not using Nickname in project.");
			}
			else {
				
				// Real name+documentation
				String lRealName = lModelElement.getName();
				if (lRealName == null || lRealName.length() == 0) {
					lRealName = "(none)";
				}
				String lRealDocumentation = lModelElement.getHTMLDocumentation();
				if (lRealDocumentation == null || lRealDocumentation.length() == 0) {
					lRealDocumentation = "(none)";
				}
				
				// Nick name+documentation
				String lNickname = lModelElement.getNickname();
				if (lNickname == null || lNickname.length() == 0) {
					lNickname = "(none)";
				}
				String lNickDocumentation = lModelElement.getNickHTMLDocumentation();
				if (lNickDocumentation == null || lNickDocumentation.length() == 0) {
					lNickDocumentation = "(none)";
				}
				
				JLabel lRealLabel = new JLabel("=== Real ===");
				lRealLabel.setFont(lRealLabel.getFont().deriveFont(Font.BOLD));
				JLabel lRealNameLabel = new JLabel("Name:");
				lRealNameLabel.setForeground(Color.gray);
				JLabel lRealNameField = new JLabel(lRealName);
				JLabel lRealDocumentationLabel = new JLabel("Documentation:");
				lRealDocumentationLabel.setForeground(Color.gray);
				JLabel lRealDocumentationField = new JLabel(lRealDocumentation);
				lRealDocumentationField.setVerticalAlignment(SwingConstants.TOP);
				
				JLabel lNickLabel = new JLabel("=== Nick: "+lProjectNickname+" ===");
				lNickLabel.setFont(lNickLabel.getFont().deriveFont(Font.BOLD));
				JLabel lNickNameLabel = new JLabel("Name:");
				lNickNameLabel.setForeground(Color.gray);
				JLabel lNickNameField = new JLabel(lNickname);
				JLabel lNickDocumentationLabel = new JLabel("Documentation:");
				lNickDocumentationLabel.setForeground(Color.gray);
				JLabel lNickDocumentationField = new JLabel(lNickDocumentation);
				lNickDocumentationField.setVerticalAlignment(SwingConstants.TOP);
				
				JPanel lPanel = new JPanel();
				{
					GridBagLayout lLayout = new GridBagLayout();
					lPanel.setLayout(lLayout);
					
					GridBagConstraints lCons = new GridBagConstraints();
					
					lCons.anchor = GridBagConstraints.WEST;
					lLayout.setConstraints(lRealLabel, lCons);
					lCons.insets.top += 5;
					lLayout.setConstraints(lRealNameLabel, lCons);
					lLayout.setConstraints(lRealDocumentationLabel, lCons);
					lCons.insets.top -= 5;
					lCons.gridwidth = GridBagConstraints.REMAINDER;
					lLayout.setConstraints(lNickLabel, lCons);
					lLayout.setConstraints(lNickNameLabel, lCons);
					lLayout.setConstraints(lNickDocumentationLabel, lCons);
					lCons.gridwidth = 1;
					
					lCons.insets.left = 10;
					lCons.weightx = 1;
					lCons.fill = GridBagConstraints.HORIZONTAL;
					lLayout.setConstraints(lRealNameField, lCons);
					lCons.gridwidth = GridBagConstraints.REMAINDER;
					lLayout.setConstraints(lNickNameField, lCons);
					lCons.gridwidth = 1;
					
					lCons.weighty = 1;
					lCons.fill = GridBagConstraints.BOTH;
					lLayout.setConstraints(lRealDocumentationField, lCons);
					lCons.gridwidth = GridBagConstraints.REMAINDER;
					lLayout.setConstraints(lNickDocumentationField, lCons);
					lCons.gridwidth = 1;
				}
				
				lPanel.add(lRealLabel);
				lPanel.add(lNickLabel);
				lPanel.add(lRealNameLabel);
				lPanel.add(lNickNameLabel);
				lPanel.add(lRealNameField);
				lPanel.add(lNickNameField);
				lPanel.add(lRealDocumentationLabel);
				lPanel.add(lNickDocumentationLabel);
				lPanel.add(lRealDocumentationField);
				lPanel.add(lNickDocumentationField);
				lPanel.setPreferredSize(new Dimension(500, 300));
				
				ApplicationManager.instance().getViewManager().showMessageDialog(null, lPanel);
				
			}
			
		}
		
	}

	public void update(VPAction aArg0, VPContext aArg1) {
	}

}
